<?php

/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */

namespace App\Http\Base;

use App\Http\Controllers\Providers\IAM\Core\Model\CoreModel;
use App\Http\Handler\SyncHandler;
use App\Http\Models\SyncUtilities\SyncHandlersModel;
use App\Http\Models\LogsynckapalModel;
use Carbon\Carbon;

class BaseModel extends CoreModel
{

    protected $tableOracle = null;
    protected $listTableNotSync = [
        "sync_table", "activitylog", "loginlog",
        "staging_sync_table", "logsynckapal", "logsyncoracle", "item_onhand", "item", "kapal", "lokasiitem",
        "administratormenu", "administratorgroupaccess", "roles", "sync", "stokkapal", "users", "voyages",
        "roles", "lotnumber", "approver", "account", "rolecategory", "rolelokasiitem", "kapallokasiitem", "itemcategory",
        "applicationparameter", "systemparameter", "pelni_scm_adj_trx_v", "pelni_scm_others_trx_v", "sync_error", "laporanbbm", "laporanbbm_details", "laporanpelumas", "laporanpelumas_details", "laporanpelumas_itemdetails"
    ];

    public function mapperOracle($oracle)
    {
        foreach ($oracle as $key => $value) {
            $this->$key = $value;
        }
    }


    public function saveToOracle($data)
    { }

    public static function storeFromHO($data)
    { }

    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "";
        return $query;
    }

    public function save(array $options = [], $server_id = null, $state = 1)
    {
        $model = parent::save($options);
        if ($GLOBALS["env"]["APLICATION_TYPE"] !== "HO") {
            if (!in_array($this->getTable(), $this->listTableNotSync)) {
                $primaryKey = $this->primaryKey;
                $sync = new SyncHandlersModel();
                $sync->getQuery()->where("sync.local_id", "=", $this->$primaryKey)
                    ->where("sync.table_name", "=", $this->getTable());
                $syncExist = $sync->getQuery()->first();
                if ($syncExist) $this->updateSync($syncExist->id, $server_id);
                else $this->storeSync($this->$primaryKey, $server_id, $state);
            }
        }

        return $model;
    }

    private function storeSync($id, $server_id = null, $state = 0)
    {
        $sync = new SyncHandlersModel();
        $sync->local_id = $id;
        $sync->table_name = $this->getTable();
        $sync->marked_deleted = 0;
        $sync->need_sync = $state;
        $sync->server_id = $server_id;
        $sync->created_at = Carbon::now()->toDateTimeString();
        $sync->updated_at = Carbon::now()->toDateTimeString();
        $sync->save();
        //(new LogsynckapalModel)->setLogSync($this->getTable() . ": Kapal to HO", Carbon::now()->toDateTimeString(), "", "success");
    }

    private function updateSync($id, $server_id = null)
    {
        $syncUpdate = SyncHandlersModel::find($id);
        $syncUpdate->need_sync = !empty($server_id) ? 1 : 0;
        $syncUpdate->updated_at = Carbon::now()->toDateTimeString();
        $syncUpdate->save();
        //(new LogsynckapalModel)->setLogSync($this->getTable() . ": Kapal to HO", Carbon::now()->toDateTimeString(), "", "success");
    }
}
